
(* process vote tables provided by ACT Electoral Commission *)

(*
fun ug _ = use "Gettbls.sml" ;

val _ = app load ["Int", "Listsort", "Gen", "Substring"] ;
*)

structure Get2001 = struct 
local open Getvotes in 
(* note, electorates are
Brindabella,1
Ginninderra,2
Molonglo,3
*)

(* format of votes file
fldID,batch,pindex,pref,ccode,pcode,rcand
1,0,11247,1,0,1,0
2,0,11247,2,1,1,0 
*)

(* get file names for 2001 election *)
val candfile = "../2001data/tblCands.txt" ; 
val elecnames = ["Brin", "Ginn", "Molo"] ;
fun mkel en = "../2001data/tbl" ^ en ^ "Electronic.txt" ;
fun mkvn en = "../2001here/" ^ en ^ "votes" ;
val vns = map mkvn elecnames ;
val pap_suffixes = [ NONE, NONE, 
  SOME ["aa", "ab", "ac", "ad", "ae", "af", "ag", "ah"]] ;
fun mkpap n en = 
  let val suffixes = List.nth (pap_suffixes, n) ;
    val basen = "../2001data/tbl" ^ en ^ "Paper.txt" ;
  in case suffixes of NONE => [basen]
      | SOME ss => map (fn s => basen ^ s) ss end ;

val candinfo = Getcands.getcands candfile ;

(* getvotes : int -> (voteid * int list) list
  get votes for electorate number n, n = 0,1,2 *)
fun getvotes n = 
  let val _ = print "Get2001.getvotes\n" ;
    val en = List.nth (elecnames, n) ;
    val filess = [mkpap n en, [mkel en]] ;
    val evec = #evec (candinfo n) ;
    val oclss as [oclpap, oclel] = map (getvf evec) filess ;
    val ocls = trappend oclel oclpap ;
  in ocls end ;

(* putvotes : (voteid * int list) list * string -> unit 
  get votes for electorate number n, n = 0,1,2 *)
fun putvotes (idvotes, file) = 
  let open TextIO ;
    val ostr = openOut file ;
    fun putvote (vid, vote) = 
      let val vstr = RPV.il2svote vote ;
      in output1 (ostr, chr (size vstr)) ; output (ostr, vstr) end ;
  in app putvote idvotes ; closeOut ostr end ;

end ; (* local open Getvotes *)
end ; (* structure Get2001 *)
(* missing preference example 
val plist =
  [[1400003, 40, 8, 1, 6], [1400003, 40, 6, 1, 3], [1400003, 40, 5, 0, 3],
  [1400003, 40, 4, 4, 3], [1400003, 40, 3, 3, 3], [1400003, 40, 2, 0, 1],
  [1400003, 40, 1, 2, 3]] : int list list
*)

(*
load "Get2001" ;
open Get2001 ;
val votess = map getvotes [0,1,2] ;
val nvs = map length votess ; (* [56604, 55708, 78528] *)
val vids = map (map #1) votess ;
val svotess = map (map (RPV.il2svote o #2)) votess ;
load "ListPair" ;
val _ = ListPair.app putvotes (votess, vns) ;

(* once votes are in ../2001here/ use the following *)
load "Get2001" ;
open Get2001 ;
val svns = map (fn s => RPV.readsvotes s ~1) vns ;
val svotess = map #2 svns ;
val nvs = map #1 svns ; (* [56604, 55708, 78528] *)

val nelecs = [5,5,7] ;

fun commLot cnt cands = cnt mod length cands 
  handle exn => raise Fail ("commLot: " ^ exnMessage exn) ;

load "Count" ; load "Tab" ;

(* n = 0,1,2 *)
fun docount n = 
  let 
    val (nc, ne, nfv, decd, commLot, votes) =
      (#ncand (candinfo n), List.nth (nelecs, n), 
      List.nth (nvs, n), [], commLot, List.nth (svotess, n)) ;
    val info = Count.prefCount (nc, ne, nfv, decd, commLot, votes) ;
    val base = List.nth (vns, n) ;
    val () = Tab.prscr info base ;
    val () = Tab.prdist info base ;
    val _ = Tab.scrcsv info base ;
  in () end ;

docount 0 ;
*)
